import 'dart:math';

import 'package:flutter/material.dart';
import 'package:graphview/GraphView.dart';

class FamilyTreePage extends StatefulWidget {
  @override
  _FamilyTreePageState createState() => _FamilyTreePageState();
}

class _FamilyTreePageState extends State<FamilyTreePage> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
        body: Column(
      mainAxisSize: MainAxisSize.max,
      children: [
        Wrap(
          children: [
            Container(
              width: 100,
              child: TextFormField(
                initialValue: builder.nodeSeparation.toString(),
                decoration: InputDecoration(labelText: "Node Separation"),
                onChanged: (text) {
                  builder.nodeSeparation = int.tryParse(text) ?? 100;
                  this.setState(() {});
                },
              ),
            ),
            Container(
              width: 100,
              child: TextFormField(
                initialValue: builder.levelSeparation.toString(),
                decoration: InputDecoration(labelText: "Level Separation"),
                onChanged: (text) {
                  builder.levelSeparation = int.tryParse(text) ?? 100;
                  this.setState(() {});
                },
              ),
            ),
            RaisedButton(
              onPressed: () {
                final Node node12 = Node(getNodeText("Name"));
                var edge = graph.getNodeAtPosition(r.nextInt(graph.nodeCount()));
                print(edge);
                graph.addEdge(edge, node12);
                setState(() {});
              },
              child: Text("Add"),
            )
          ],
        ),
        Expanded(
          child: InteractiveViewer(
              constrained: false,
              boundaryMargin: EdgeInsets.all(100),
              minScale: 0.01,
              maxScale: 5.6,
              child: GraphView(
                graph: graph,
                algorithm: SugiyamaAlgorithm(builder),
                paint: Paint()..color = Colors.green..strokeWidth = 1..style = PaintingStyle.stroke,
              )),
        ),
      ],
    ));
  }

  Random r = Random();

  int n = 1;

  Widget getNodeText(String text,{BoxShape shape = BoxShape.circle}) {
    return Container(
        padding: EdgeInsets.all(16),
        decoration: BoxDecoration(
          color: Colors.red,
          shape: shape,
        ),
        child: Text(text));
  }

  final Graph graph = Graph();

  SugiyamaConfiguration builder = SugiyamaConfiguration();

  var tree = [
    { "id": 1, "name": "Me", "dob": "1988", "children": [4], "partners" : [2,3], "root":true, "level": 0, "parents": [5,6] },
    { "id": 2, "name": "Mistress 1", "dob": "1987", "children": [4], "partners" : [1], "level": 0, "parents": [] },
    { "id": 3, "name": "Wife 1", "dob": "1988", "children": [5], "partners" : [1], "level": 0, "parents": [] },
    { "id": 4, "name": "son 1", "dob": "", "children": [], "partners" : [], "level": -1, "parents": [1,2] },
    { "id": 5, "name": "daughter 1", "dob": "", "children": [7], "partners" : [6], "level": -1, "parents": [1,3] },
    { "id": 6, "name": "daughter 1s boyfriend", "dob": "", "children": [7], "partners" : [5], "level": -1, "parents": [] },
    { "id": 7, "name": "son (bottom most)", "dob": "", "children": [], "partners" : [], "level": -2, "parents": [5,6] },
    { "id": 8, "name": "jeff", "dob": "", "children": [1], "partners" : [9], "level": 1, "parents": [10,11] },
    { "id": 9, "name": "maggie", "dob": "", "children": [1], "partners" : [8], "level": 1, "parents": [] },
    { "id": 10, "name": "bob", "dob": "", "children": [8], "partners" : [11], "level": 2, "parents": [12] },
    { "id": 11, "name": "mary", "dob": "", "children": [], "partners" : [10], "level": 2, "parents": [] },
    { "id": 12, "name": "john", "dob": "", "children": [10], "partners" : [], "level": 3, "parents": [] },
    { "id": 13, "name": "robert", "dob": "", "children": [9], "partners" : [], "level": 2, "parents": [] },
    { "id": 14, "name": "jessie", "dob": "", "children": [9], "partners" : [], "level": 2, "parents": [15,16] },
    { "id": 15, "name": "raymond", "dob": "", "children": [14], "partners" : [], "level": 3, "parents": [] },
    { "id": 16, "name": "betty", "dob": "", "children": [14], "partners" : [], "level": 3, "parents": [] },
  ];

  @override
  void initState() {
//    final Node node1 = Node(getNodeText("Me"));
//    final Node node2 = Node(getNodeText("Wife"));
//    final Node node3 = Node(getNodeText("Mistress"));
//    final Node node4 = Node(getNodeText("Son"));
//    final Node node5 = Node(getNodeText("Daughter 1"));
//    final Node node6 = Node(getNodeText("Daughter 1's husband"));
//    final Node node8 = Node(getNodeText("Son"));
//    final Node node7 = Node(getNodeText("Jawad"));
//    final Node node9 = Node(getNodeText("Maliha"));
//    final Node node10 = Node(getNodeText("Bob"));
//    final Node node11 = Node(getNodeText("Maryam"));
//    final Node node12 = Node(getNodeText("Yahya"));
//    final Node node13 = Node(getNodeText("Robert"));
//    final Node node14 = Node(getNodeText("Jim"));
//    final Node node15 = Node(getNodeText("Raymond"));
//    final Node node16 = Node(getNodeText("Betty"));
//
//
//
//    graph.addEdge(node1, node5);
//    graph.addEdge(node7, node1);
//    graph.addEdge(node9, node1);
//    graph.addEdge(node1, node4);
//    graph.addEdge(node2, node4);
//    graph.addEdge(node3, node5);
//    graph.addEdge(node1, node5);

    var id1= [30175, 20031, 20020, 11368, 11053, 17].reversed.toList();
    var id2=[30160, 20173, 20020, 11369, 11053, 17].reversed.toList();
    var id3= [30160, 20173, 20020, 11369, 11053].reversed.toList();

    var hadith1 = "2";
    var hadith2 = "3";
    var hadith3 = "4";

    final Node prophet = Node(getNodeText("Prophet"));

    for(var i= 0; i<id1.length ; i++) {
      var prevNode = i ==0 ? prophet : Node(getNodeText(id1[i -1].toString()), key: ValueKey(id1[i-1]));
      var node = Node(getNodeText(id1[i].toString()), key: ValueKey(id1[i]));
      graph.addEdge(prevNode, node);

      if(i==id1.length-1) {
        var hadithNode = Node(getNodeText(hadith1));
        graph.addEdge(node, hadithNode);
      }
    }

    for(int i= 0; i<id2.length ; i++) {
      var prevNode = i ==0 ? prophet : Node(getNodeText(id2[i -1].toString()), key: ValueKey(id2[i-1]));
      var node = Node(getNodeText(id2[i].toString()), key: ValueKey(id2[i]));
      graph.addEdge(prevNode, node);
      if(i==id2.length-1) {
        var hadithNode = Node(getNodeText(hadith2));
        graph.addEdge(node, hadithNode);
      }
    }

    for(int i= 0; i<id3.length ; i++) {
      var prevNode = i ==0 ? prophet : Node(getNodeText(id3[i -1].toString()), key: ValueKey(id3[i-1]));
      var node = Node(getNodeText(id3[i].toString()), key: ValueKey(id3[i]));
      graph.addEdge(prevNode, node);

      if(i==id3.length-1) {
        var hadithNode = Node(getNodeText(hadith3));
        graph.addEdge(node, hadithNode);
      }
    }

    builder
      ..nodeSeparation = (15)
      ..levelSeparation = (15);

  }
}
